/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package org.apache.hadoop.fs.aliyun.oss.fileContext;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileContextURIBase;
import org.apache.hadoop.fs.aliyun.oss.AliyunOSSTestUtils;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

import java.io.IOException;

/**
 * OSS implementation of FileContextURIBase.
 */
public class TestOSSFileContextURI extends FileContextURIBase {

  @Before
  public void setUp() throws IOException, Exception {
    Configuration conf = new Configuration();
    fc1 = AliyunOSSTestUtils.createTestFileContext(conf);
    // different object, same FS
    fc2 = AliyunOSSTestUtils.createTestFileContext(conf);
    super.setUp();
  }

  @Test
  @Ignore
  public void testFileStatus() throws IOException {
    // test ignored
    // (the statistics tested with this method are not relevant for an OSSFS)
  }
}
